// Gestore.java

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.net.*;


		

public class Gestore extends HttpServlet
  {
//
// Per ogni servizio registrato sul web server, viene creato un oggetto distinto, anche se la 
// classe  una sola. Alla creazione di ciasun oggetto vengono letti i parametri di 
// inizializzazione, specifici dell'oggetto, a meno che non siano static. L'oggetto resta in
// vita per sempre. Le variabili static sono condivise le altre no. 
//

  public String nomeClasse;
  public static InfoServer info;
  
  int caricoMinimo;
  int nodoConCaricoMinimo;

/////////////////////////////////////////////////////////////////////////////////   
//
// Inizializzazione
//      
/////////////////////////////////////////////////////////////////////////////////

	public void init (ServletConfig config) throws ServletException
		{
    
    super.init(config);
		nomeClasse = new String(getInitParameter("nomeClasse"));
		if (nomeClasse.compareToIgnoreCase("Init")==0)

			{
			info=new InfoServer();
			info.start();
			info.numeroNodi = Integer.parseInt(getInitParameter("numeroNodi"));
			info.mioNodo = Integer.parseInt(getInitParameter("mioNodo"))-1;
			info.gap = Integer.parseInt(getInitParameter("gap"));  
			info.fasciaDiCarico=0;
			int n;
			for (n=0;n<info.numeroNodi;n++)
	   		{
	   		info.nomeServer[n] = new String(getInitParameter("nomeServer"+String.valueOf(n+1)));     		
	     	info.carico[n]=0;//Non conosco il carico dei nodi, inizialmente lo pongo alto.
	     	};
	        
	    info.stampaStatoDeiServer();
	   	info.carico[info.mioNodo]=0;

	   	System.out.println("nome del mio Nodo");  
	   	System.out.println(info.nomeServer[info.mioNodo]);
	    System.out.println("********************");  
	
	   
			};
		};		

///////////////////////////////////////////////////////////////////////////////
//
// AGGIORNA FASCIA DI CARICO
//
///////////////////////////////////////////////////////////////////////////////

  public void aggiornaFasciaDiCarico()
  	{
  	if (Math.abs(info.carico[info.mioNodo]-info.fasciaDiCarico)==info.gap)
      {
    	info.fasciaDiCarico=(info.carico[info.mioNodo]);
    	info.doMulticast(info.fasciaDiCarico);
    	}
  	};

///////////////////////////////////////////////////////////////////////////////
//
// TROVA CARICO MINIMO
//
///////////////////////////////////////////////////////////////////////////////
 
  public void trovaCaricoMinimo()
  	{
  	int n;
  	caricoMinimo=10000;
    nodoConCaricoMinimo=-1;
  			
  	for (n=0;n<info.numeroNodi;n++)
  		{
  		if (info.carico[n]<caricoMinimo)
  			{			
  			caricoMinimo=info.carico[n];			
  			nodoConCaricoMinimo=n;
  			System.out.println("Carico minimo trovato e nodo: "+caricoMinimo+" sul nodo "+nodoConCaricoMinimo);
  			System.out.println("********************"); 
  			};
  		};
  	};
  		
///////////////////////////////////////////////////////////////////////////////
//
// DOGET
//    
///////////////////////////////////////////////////////////////////////////////	

  public void doGet (HttpServletRequest request,HttpServletResponse response)
    throws ServletException, IOException
    {      
		
		if (nomeClasse.compareToIgnoreCase("Init")!=0)
    	{
    		
		 	trovaCaricoMinimo();
		 	
     	System.out.println("Nodo carico minimo e carico prima del servizio: "+info.nomeServer[nodoConCaricoMinimo]+" "+caricoMinimo);
			System.out.println("Carico mio nodo prima del servizio: "+info.carico[info.mioNodo]);
			System.out.println("********************");
	    
	    if (caricoMinimo <= (info.carico[info.mioNodo]-info.gap))
    		{
    		String invocazioneServizio,queryString;	         			  	  	
	  	  PrintWriter outToClient=response.getWriter();
	  	  response.setContentType("text/html");
				invocazioneServizio = "http://"+info.nomeServer[nodoConCaricoMinimo]+":8080"+request.getServletPath();
				queryString=request.getQueryString();
				if (queryString!=null) invocazioneServizio=invocazioneServizio+"?"+queryString;
	      outToClient.println("<HTML>");
	      outToClient.println("<HEAD>");
	      outToClient.println("<TITLE>Pagina per la connessione automatica</TITLE>");
	      outToClient.print("<META HTTP-EQUIV=\"REFRESH\" CONTENT=\"6 URL=");
				outToClient.print(invocazioneServizio);
				outToClient.println("\">");
	      outToClient.println("</HEAD>");
	      outToClient.println("<body>");
	      outToClient.println("<H1>Progetto per Reti di Calcolatori</H1>");
	      outToClient.println("<P>Questa  l'invocazione di una copia del servitore");
	      outToClient.println("</body>");
	      outToClient.println("</HTML>");
	      outToClient.close();
	  		}
	    	
	    else   // Esegui il servizio!
	  		{
				info.carico[info.mioNodo]++;
				aggiornaFasciaDiCarico();
				info.stampaStatoDeiServer();
				
			  try
			    {
			    Class	classeServizio = Class.forName(nomeClasse);
			    Object istanzaServizio = classeServizio.newInstance();
		      ((servizioGet)istanzaServizio).doGet(request,response);
	  		  }
			  catch (IllegalAccessException e)
			    {
			    e.printStackTrace();
			    }
			  catch (InstantiationException e)
			 	  {
			 	  e.printStackTrace();
			 	  }
			  catch (ClassNotFoundException e)
			    {
			    e.printStackTrace();
			    }  
			       
	      info.carico[info.mioNodo]--;
	      info.stampaStatoDeiServer();	
	      aggiornaFasciaDiCarico();
		   	
	      	
    		}	
      }
  	}
  
/////////////////////////////////////////////////////////////////////////////////
//
// 	DO POST
//
/////////////////////////////////////////////////////////////////////////////////      
 
  public void doPost (HttpServletRequest request,HttpServletResponse response)
    throws ServletException, IOException
    {      

		trovaCaricoMinimo();
		 	
    System.out.println("Nodo carico minimo e carico prima del servizio: "+info.nomeServer[nodoConCaricoMinimo]+" "+caricoMinimo);
		System.out.println("Carico mio nodo prima del servizio: "+info.carico[info.mioNodo]);
		System.out.println("********************");


		if (caricoMinimo <= (info.carico[info.mioNodo]-info.gap))	
  	  {
  	  String invocazioneServizio; 
  	  PrintWriter outToClient=response.getWriter();
  	  response.setContentType("text/html");
      Enumeration values = request.getParameterNames();
      invocazioneServizio = info.nomeServer[nodoConCaricoMinimo]+":8080"+request.getServletPath();
    	outToClient.println("<HTML>");
      outToClient.println("<HEAD>");
      outToClient.println("<TITLE>Pagina per la connessione automatica</TITLE>");
      outToClient.println("<script language=\"JavaScript\">");
			outToClient.println("<!-- serve a nascondere lo script ai browser che non lo supportano");
			outToClient.println("function invia()");
			outToClient.println("{");
			outToClient.println("autoform.submit();");
			outToClient.println("}");
			outToClient.println("-->");			
			outToClient.println("</script>");
      outToClient.println("</HEAD>");
      outToClient.println("<body OnLoad=\"invia()\">");
      outToClient.println("<H1>Progetto per Reti di Calcolatori</H1>");
      outToClient.println("<P>Questa  l'invocazione di una copia del servitore con il metodo POST");
      outToClient.print("<form action=http://");
      outToClient.print(invocazioneServizio);
      outToClient.println(" method=POST name=\"autoform\">");
      while (values.hasMoreElements())
        {
        String name =(String)values.nextElement();
        int n=0;
        for (n=0;n<(request.getParameterValues(name).length);n++)
         	{
         	String value=request.getParameterValues(name)[n];
	        outToClient.print("<input type=hidden name=");
	        outToClient.print(name);
	        outToClient.print(" value=");
	        outToClient.print(value);
	        outToClient.println(">");
	        n++;
        	};
        };
      outToClient.println("</form>");      		      		      		      
      outToClient.println("</body>");
      outToClient.println("</HTML>");
      outToClient.close();
  		}
	      	
      else   // Esegui il servizio!
      	{
				info.carico[info.mioNodo]++;
				aggiornaFasciaDiCarico();
				info.stampaStatoDeiServer();

				try
			    {
			    Class	classeServizio = Class.forName(nomeClasse);
			    Object istanzaServizio = classeServizio.newInstance();
  	      ((servizioPost)istanzaServizio).doPost(request,response);
	  		  }
			  catch (IllegalAccessException e)
			    {
			    e.printStackTrace();
			    }
			  catch (InstantiationException e)
			 	  {
			 	  e.printStackTrace();
			 	  }
			  catch (ClassNotFoundException e)
			    {
			    e.printStackTrace();
			    }
				       
	      info.carico[info.mioNodo]--;
	      info.stampaStatoDeiServer();	
	      aggiornaFasciaDiCarico();
      	}
      } 
    }
    